window.ontabFunction = function(event, ctrlId) {
    console.log(ctrlId);

    var tabIndices = {
        sbsbid: {
            prev: 'lineunits',
            next: 'suffix'
        },
        suffix: {
            prev: 'sbsbid',
            next: 'memberselect'
        },
        memberselect: {
            prev: 'suffix',
            next: 'prprid'
        },
        prprid: {
            prev: 'memberselect',
            next: 'receiveddate'
        },
        receiveddate: {
            prev: 'prprid',
            next: 'totalcharge'
        },
        totalcharge: {
            prev: 'receiveddate',
            next: 'patientpaid'
        },
        patientpaid: {
            prev: 'totalcharge',
            next: 'memo'
        },
        memo: {
            prev: 'patientpaid',
            next: 'diag1'
        },
        diag1: {
            prev: 'memo',
            next: 'diag2'
        },
        diag2: {
            prev: 'diag1',
            next: 'diag3'
        },
        diag3: {
            prev: 'diag2',
            next: 'diag4'
        },
        diag4: {
            prev: 'diag3',
            next: 'diag5'
        },
        diag5: {
            prev: 'diag4',
            next: 'diag6'
        },
        diag6: {
            prev: 'diag5',
            next: 'diag7'
        },
        diag7: {
            prev: 'diag6',
            next: 'diag8'
        },
        diag8: {
            prev: 'diag7',
            next: 'diag9'
        },
        diag9: {
            prev: 'diag8',
            next: 'diag10'
        },
        diag10: {
            prev: 'diag9',
            next: 'diag11'
        },
        diag11: {
            prev: 'diag10',
            next: 'diag12'
        },
        diag12: {
            prev: 'diag11',
            next: 'referringphysician',
            section: 'additionalinfopanel',
            nextSection: 'linefrom'
        },
        referringphysician: {
            prev: 'diag12',
            next: 'referringfacility'
        },
        referringfacility: {
            prev: 'referringphysician',
            next: 'auth'
        },
        auth: {
            prev: 'referringfacility',
            next: 'patientaccount'
        },
        patientaccount: {
            prev: 'auth',
            next: 'provtaxcode'
        },
        provtaxcode: {
            prev: 'patientaccount',
            next: 'outsidelab'
        },
        outsidelab: {
            prev: 'provtaxcode',
            next: 'cobexists'
        },
        cobexists: {
            prev: 'outsidelab',
            next: 'acceptassignments'
        },
        acceptassignments: {
            prev: 'cobexists',
            next: 'additionalClaimFieldsReqID'
        },
        additionalClaimFieldsReqID: {
            prev: 'acceptassignments',
            next: 'condrelatedto',
            section: 'additionalClaimsForm',
            nextSection: 'linefrom'
        },
        condrelatedto: {
            prev: 'acceptassignments',
            next: 'state',
            nextSection: 'linefrom'
        },
        state: {
            prev: 'acceptassignments',
            next: 'conddate',
            nextSection: 'linefrom'
        },
        conddate: {
            prev: 'acceptassignments',
            next: 'relatedfrom',

            nextSection: 'linefrom'
        },
        relatedfrom: {
            prev: 'acceptassignments',
            next: 'relatedto',

            nextSection: 'linefrom'
        },
        relatedto: {
            prev: 'acceptassignments',
            next: 'hospfrom',

            nextSection: 'linefrom'
        },
        hospfrom: {
            prev: 'acceptassignments',
            next: 'hospto',

            nextSection: 'linefrom'
        },
        hospto: {
            prev: 'acceptassignments',
            next: 'datecurrillness',

            nextSection: 'linefrom'
        },
        datecurrillness: {
            prev: 'hospto',
            next: 'firstilldate',

            nextSection: 'linefrom'
        },
        firstilldate: {
            prev: 'acceptassignments',
            next: 'resubmissionno',

            nextSection: 'linefrom'
        },
        resubmissionno: {
            prev: 'acceptassignments',
            next: 'externalref',

            nextSection: 'linefrom'
        },
        externalref: {
            prev: 'acceptassignments',
            next: 'othercarr',

            nextSection: 'linefrom'
        },
        othercarr: {
            prev: 'acceptassignments',
            next: 'xrays',

            nextSection: 'linefrom'
        },
        xrays: {
            prev: 'othercarr',
            next: 'medrecs',

            nextSection: 'linefrom'
        },
        medrecs: {
            prev: 'xrays',
            next: 'linefrom',
        },
        linefrom: {
            prevSection: 'diag12',
            prev: 'acceptassignments',
            next: 'lineto'
        },
        lineto: {
            prev: 'linefrom',
            next: 'linepos'
        },
        linepos: {
            prev: 'lineto',
            next: 'linetos'
        },
        linetos: {
            prev: 'linepos',
            next: 'lineproc'
        },
        lineproc: {
            prev: 'linetos',
            next: 'linediag'
        },
        linediag: {
            prev: 'lineproc',
            next: 'linechg'
        },
        linechg: {
            prev: 'linediag',
            next: 'lineunits'
        },
        lineunits: {
            prev: 'linechg',
            next: 'sbsbid'
        }
    }

    if (event.key == "Tab") {
        if (event.shiftKey) {
            var prevId = tabIndices[ctrlId].prev;
            document.getElementById(prevId).focus();
        } else {
            var section = tabIndices[ctrlId].section;
            var nextId = tabIndices[ctrlId].next;
            if (section) {
                // Check if the section is displayed
                if (document.getElementById(section).style.display != 'none') {
                    console.log('Section Enabled');
                } else {
                    nextId = tabIndices[ctrlId].nextSection;
                }
            }
            
            var el = document.getElementById(nextId);
            el.focus();
        }

        var dt = new Date();
        var dtStr = dt.toJSON().slice(0, 10);
        if (nextId == 'receiveddate') {
            var el = document.getElementById(nextId);
            el.value = dtStr;
        }

        if (ctrlId == 'lineto') {
            if (document.getElementById('linefrom').value != '') {
                document.getElementById(ctrlId).value = document.getElementById('linefrom').value;
            }
            console.log(document.getElementById(ctrlId).value);
        }

        event.preventDefault();
    }
}

window.ontabFunction1 = function(event, ctrlId) {
    console.log(ctrlId);

    var tabIndices = {
        sbsbid: {
            prev: 'lineunits',
            next: 'suffix'
        },
        suffix: {
            prev: 'sbsbid',
            next: 'memberselect'
        },
        memberselect: {
            prev: 'suffix',
            next: 'prprid'
        },
        prprid: {
            prev: 'memberselect',
            next: 'receiveddate'
        },
        receiveddate: {
            prev: 'prprid',
            next: 'totalcharge'
        },
        totalcharge: {
            prev: 'receiveddate',
            next: 'patientpaid'
        },
        patientpaid: {
            prev: 'totalcharge',
            next: 'diag1'
        },
        memo: {
            prev: 'diag12',
            next: 'referringphysician',
            section: 'additionalinfopanel',
            nextSection: 'linefrom'
        },
        diag1: {
            prev: 'memo',
            next: 'diag2'
        },
        diag2: {
            prev: 'diag1',
            next: 'diag3'
        },
        diag3: {
            prev: 'diag2',
            next: 'diag4'
        },
        diag4: {
            prev: 'diag3',
            next: 'diag5'
        },
        diag5: {
            prev: 'diag4',
            next: 'diag6'
        },
        diag6: {
            prev: 'diag5',
            next: 'diag7'
        },
        diag7: {
            prev: 'diag6',
            next: 'diag8'
        },
        diag8: {
            prev: 'diag7',
            next: 'diag9'
        },
        diag9: {
            prev: 'diag8',
            next: 'diag10'
        },
        diag10: {
            prev: 'diag9',
            next: 'diag11'
        },
        diag11: {
            prev: 'diag10',
            next: 'diag12'
        },
        diag12: {
            prev: 'diag11',
            next: 'memo', // 'referringphysician',
        },
        referringphysician: {
            prev: 'diag12',
            next: 'referringfacility'
        },
        referringfacility: {
            prev: 'referringphysician',
            next: 'auth'
        },
        auth: {
            prev: 'referringfacility',
            next: 'patientaccount'
        },
        patientaccount: {
            prev: 'auth',
            next: 'provtaxcode'
        },
        provtaxcode: {
            prev: 'patientaccount',
            next: 'outsidelab'
        },
        outsidelab: {
            prev: 'provtaxcode',
            next: 'cobexists'
        },
        cobexists: {
            prev: 'outsidelab',
            next: 'acceptassignments'
        },
        acceptassignments: {
            prev: 'cobexists',
            next: 'additionalClaimFieldsReqID'
        },
        additionalClaimFieldsReqID: {
            prev: 'acceptassignments',
            next: 'condrelatedto',
            section: 'additionalClaimsForm',
            nextSection: 'linefrom'
        },
        condrelatedto: {
            prev: 'acceptassignments',
            next: 'state',
            nextSection: 'linefrom'
        },
        state: {
            prev: 'acceptassignments',
            next: 'conddate',
            nextSection: 'linefrom'
        },
        conddate: {
            prev: 'acceptassignments',
            next: 'relatedfrom',

            nextSection: 'linefrom'
        },
        relatedfrom: {
            prev: 'acceptassignments',
            next: 'relatedto',

            nextSection: 'linefrom'
        },
        relatedto: {
            prev: 'acceptassignments',
            next: 'hospfrom',

            nextSection: 'linefrom'
        },
        hospfrom: {
            prev: 'acceptassignments',
            next: 'hospto',

            nextSection: 'linefrom'
        },
        hospto: {
            prev: 'acceptassignments',
            next: 'datecurrillness',

            nextSection: 'linefrom'
        },
        datecurrillness: {
            prev: 'hospto',
            next: 'firstilldate',

            nextSection: 'linefrom'
        },
        firstilldate: {
            prev: 'acceptassignments',
            next: 'resubmissionno',

            nextSection: 'linefrom'
        },
        resubmissionno: {
            prev: 'acceptassignments',
            next: 'externalref',

            nextSection: 'linefrom'
        },
        externalref: {
            prev: 'acceptassignments',
            next: 'othercarr',

            nextSection: 'linefrom'
        },
        othercarr: {
            prev: 'acceptassignments',
            next: 'xrays',

            nextSection: 'linefrom'
        },
        xrays: {
            prev: 'othercarr',
            next: 'medrecs',

            nextSection: 'linefrom'
        },
        medrecs: {
            prev: 'xrays',
            next: 'linefrom',
        },
        linefrom: {
            prevSection: 'diag12',
            prev: 'acceptassignments',
            next: 'lineto'
        },
        lineto: {
            prev: 'linefrom',
            next: 'linepos'
        },
        linepos: {
            prev: 'lineto',
            next: 'linetos'
        },
        linetos: {
            prev: 'linepos',
            next: 'lineproc'
        },
        lineproc: {
            prev: 'linetos',
            next: 'linediag'
        },
        linediag: {
            prev: 'lineproc',
            next: 'linechg'
        },
        linechg: {
            prev: 'linediag',
            next: 'lineunits'
        },
        lineunits: {
            prev: 'linechg',
            next: 'sbsbid'
        }
    }

    if (event.key == "Tab") {
        if (event.shiftKey) {
            var prevId = tabIndices[ctrlId].prev;
            document.getElementById(prevId).focus();
        } else {
            var section = tabIndices[ctrlId].section;
            var nextId = tabIndices[ctrlId].next;
            if (section) {
                // Check if the section is displayed
                if (document.getElementById(section).style.display != 'none') {
                    console.log('Section Enabled');
                } else {
                    nextId = tabIndices[ctrlId].nextSection;
                }
            }
            
            var el = document.getElementById(nextId);
            el.focus();
        }

        var dt = new Date();
        var dtStr = dt.toJSON().slice(0, 10);
        if (nextId == 'receiveddate') {
            var el = document.getElementById(nextId);
            el.value = dtStr;
        }

        if (ctrlId == 'lineto') {
            if (document.getElementById('linefrom').value != '') {
                document.getElementById(ctrlId).value = document.getElementById('linefrom').value;
            }
            console.log(document.getElementById(ctrlId).value);
        }

        event.preventDefault();
    }
}

window.onDiagLoseFocus = function(id) {
    var diagNo = id.substring(4);
    var text = document.getElementById(id).value;
    var str = diagNo;
    if (text.length) str += " - " + text + " - Diag Description";
    var el = document.getElementById(id);
    el.value = str;
}

window.addClaimLine = function() {
    var table = document.getElementById("claimLineData");
    var lineno = table.rows.length;
    var newRow = table.rows[lineno-1].cloneNode(true);
    
    newRow.cells[0].firstChild.value = lineno;
    table.appendChild(newRow);
}

window.additionalinfopanelexpand = function(event) {
    console.log(event);
    if (event.target.classList.contains('fa-caret-down')) {
        // collapsed;
        event.target.className = 'fa fa-2x fa-caret-up';
        var panel = document.getElementById('additionalinfopanel');
        panel.style.display = '';
    } else {
        // expanded;
        event.target.className = 'fa fa-2x fa-caret-down';
        var panel = document.getElementById('additionalinfopanel');
        panel.style.display = 'none';
    }
}

window.additionalClaimFieldsReq = function(event) {
    console.log(event);
    var els = document.getElementsByName('additionalClaimFieldsReq');
    var yes = false;
    for (var i = 0; i < els.length; i++) {
        if (els[i].checked) {
            if (els[i].value == "Yes") yes = true;
            break;
        }
    }
    var el = document.getElementById('additionalClaimsForm');
    if (yes) {
        el.style.display = '';
    } else {
        el.style.display = 'none';
    }
}

window.removeLine = function(event) {
    console.log(event);
    var table1 = document.getElementById("claimLineData");
    if (table1.rows.length == 2) return;
    var table = event.target.parentElement.parentElement.parentElement;
    var row = event.target.parentElement.parentElement;
    table.removeChild(row);
    
    
    for (var i = 1; i < table1.rows.length; i++) {
        table1.rows[i].cells[0].firstChild.value = i;
    }
    
    
}